// ======================================= //
//                                         //
//                    //
//     Windows HTTP Services (WinHTTP)     //
//                                         //
//               HiAsm               //
//             www.hiasm.com               //
//                                         //
//            : Netspirit             //
//        E-mail: netspirit@meta.ua        //
//                                         //
// ======================================= //

unit WinHTTP;

interface

uses
  Windows, WinInet;



type
  WINHTTP_STATUS_CALLBACK = procedure (InternetH: HINTERNET; dwContext: Pointer; dwInternetStatus: DWORD; lpvStatusInformation: Pointer; dwStatusInformationLength: DWORD); stdcall;


const
  winhttpdll = 'winhttp.dll';

  WINHTTP_ACCESS_TYPE_DEFAULT_PROXY = 0;
  WINHTTP_ACCESS_TYPE_NO_PROXY      = 1;
  WINHTTP_ACCESS_TYPE_NAMED_PROXY   = 3;

  WINHTTP_NO_PROXY_NAME             =  nil;
  WINHTTP_NO_PROXY_BYPASS           =  nil;


  WINHTTP_FLAG_ASYNC                = $10000000;


  WINHTTP_NO_REFERER                =  nil;
  WINHTTP_DEFAULT_ACCEPT_TYPES      =  nil;

  WINHTTP_FLAG_REFRESH              = $00000100;
  WINHTTP_FLAG_SECURE               = $00800000;

  WINHTTP_ADDREQ_FLAG_ADD_IF_NEW               = $10000000;
  WINHTTP_ADDREQ_FLAG_ADD                      = $20000000;
  WINHTTP_ADDREQ_FLAG_COALESCE_WITH_COMMA      = $40000000;
  WINHTTP_ADDREQ_FLAG_COALESCE_WITH_SEMICOLON  = $01000000;
  WINHTTP_ADDREQ_FLAG_COALESCE                 = WINHTTP_ADDREQ_FLAG_COALESCE_WITH_COMMA;
  WINHTTP_ADDREQ_FLAG_REPLACE                  = $80000000;

  WINHTTP_HEADER_NAME_BY_INDEX     = nil;
  WINHTTP_NO_OUTPUT_BUFFER         = nil;
  WINHTTP_NO_HEADER_INDEX          = nil;
  
  WINHTTP_AUTH_SCHEME_BASIC      = $00000001;
  WINHTTP_AUTH_SCHEME_NTLM       = $00000002;
  WINHTTP_AUTH_SCHEME_PASSPORT   = $00000004;
  WINHTTP_AUTH_SCHEME_DIGEST     = $00000008;
  WINHTTP_AUTH_SCHEME_NEGOTIATE  = $00000010;

  WINHTTP_AUTH_TARGET_SERVER     = $00000000;
  WINHTTP_AUTH_TARGET_PROXY      = $00000001;
  
//  WinHTTP error codes
  WINHTTP_ERROR_BASE                                  = 12000;
  ERROR_WINHTTP_OUT_OF_HANDLES                        = (WINHTTP_ERROR_BASE + 1);
  ERROR_WINHTTP_TIMEOUT                               = (WINHTTP_ERROR_BASE + 2);
  ERROR_WINHTTP_INTERNAL_ERROR                        = (WINHTTP_ERROR_BASE + 4);
  ERROR_WINHTTP_INVALID_URL                           = (WINHTTP_ERROR_BASE + 5);
  ERROR_WINHTTP_UNRECOGNIZED_SCHEME                   = (WINHTTP_ERROR_BASE + 6);
  ERROR_WINHTTP_NAME_NOT_RESOLVED                     = (WINHTTP_ERROR_BASE + 7);
  ERROR_WINHTTP_INVALID_OPTION                        = (WINHTTP_ERROR_BASE + 9);
  ERROR_WINHTTP_OPTION_NOT_SETTABLE                   = (WINHTTP_ERROR_BASE + 11);
  ERROR_WINHTTP_SHUTDOWN                              = (WINHTTP_ERROR_BASE + 12);
  ERROR_WINHTTP_LOGIN_FAILURE                         = (WINHTTP_ERROR_BASE + 15);
  ERROR_WINHTTP_OPERATION_CANCELLED                   = (WINHTTP_ERROR_BASE + 17);
  ERROR_WINHTTP_INCORRECT_HANDLE_TYPE                 = (WINHTTP_ERROR_BASE + 18);
  ERROR_WINHTTP_INCORRECT_HANDLE_STATE                = (WINHTTP_ERROR_BASE + 19);
  ERROR_WINHTTP_CANNOT_CONNECT                        = (WINHTTP_ERROR_BASE + 29);
  ERROR_WINHTTP_CONNECTION_ERROR                      = (WINHTTP_ERROR_BASE + 30);
  ERROR_WINHTTP_RESEND_REQUEST                        = (WINHTTP_ERROR_BASE + 32);
  ERROR_WINHTTP_SECURE_CERT_DATE_INVALID              = (WINHTTP_ERROR_BASE + 37);
  ERROR_WINHTTP_SECURE_CERT_CN_INVALID                = (WINHTTP_ERROR_BASE + 38);
  ERROR_WINHTTP_CLIENT_AUTH_CERT_NEEDED               = (WINHTTP_ERROR_BASE + 44);
  ERROR_WINHTTP_SECURE_INVALID_CA                     = (WINHTTP_ERROR_BASE + 45);
  ERROR_WINHTTP_SECURE_CERT_REV_FAILED                = (WINHTTP_ERROR_BASE + 57);
  ERROR_WINHTTP_CANNOT_CALL_BEFORE_OPEN               = (WINHTTP_ERROR_BASE + 100);
  ERROR_WINHTTP_CANNOT_CALL_BEFORE_SEND               = (WINHTTP_ERROR_BASE + 101);
  ERROR_WINHTTP_CANNOT_CALL_AFTER_SEND                = (WINHTTP_ERROR_BASE + 102);
  ERROR_WINHTTP_CANNOT_CALL_AFTER_OPEN                = (WINHTTP_ERROR_BASE + 103);
  ERROR_WINHTTP_HEADER_NOT_FOUND                      = (WINHTTP_ERROR_BASE + 150);
  ERROR_WINHTTP_INVALID_SERVER_RESPONSE               = (WINHTTP_ERROR_BASE + 152);
  ERROR_WINHTTP_INVALID_HEADER                        = (WINHTTP_ERROR_BASE + 153);
  ERROR_WINHTTP_INVALID_QUERY_REQUEST                 = (WINHTTP_ERROR_BASE + 154);
  ERROR_WINHTTP_HEADER_ALREADY_EXISTS                 = (WINHTTP_ERROR_BASE + 155);
  ERROR_WINHTTP_REDIRECT_FAILED                       = (WINHTTP_ERROR_BASE + 156);
  ERROR_WINHTTP_SECURE_CHANNEL_ERROR                  = (WINHTTP_ERROR_BASE + 157);
  ERROR_WINHTTP_BAD_AUTO_PROXY_SCRIPT                 = (WINHTTP_ERROR_BASE + 166);
  ERROR_WINHTTP_UNABLE_TO_DOWNLOAD_SCRIPT             = (WINHTTP_ERROR_BASE + 167);
  ERROR_WINHTTP_SECURE_INVALID_CERT                   = (WINHTTP_ERROR_BASE + 169);
  ERROR_WINHTTP_SECURE_CERT_REVOKED                   = (WINHTTP_ERROR_BASE + 170);
  ERROR_WINHTTP_NOT_INITIALIZED                       = (WINHTTP_ERROR_BASE + 172);
  ERROR_WINHTTP_SECURE_FAILURE                        = (WINHTTP_ERROR_BASE + 175);
  ERROR_WINHTTP_AUTO_PROXY_SERVICE_ERROR              = (WINHTTP_ERROR_BASE + 178);
  ERROR_WINHTTP_SECURE_CERT_WRONG_USAGE               = (WINHTTP_ERROR_BASE + 179);
  ERROR_WINHTTP_AUTODETECTION_FAILED                  = (WINHTTP_ERROR_BASE + 180);
  ERROR_WINHTTP_HEADER_COUNT_EXCEEDED                 = (WINHTTP_ERROR_BASE + 181);
  ERROR_WINHTTP_HEADER_SIZE_OVERFLOW                  = (WINHTTP_ERROR_BASE + 182);
  ERROR_WINHTTP_CHUNKED_ENCODING_HEADER_SIZE_OVERFLOW = (WINHTTP_ERROR_BASE + 183);
  ERROR_WINHTTP_RESPONSE_DRAIN_OVERFLOW               = (WINHTTP_ERROR_BASE + 184);
  ERROR_WINHTTP_CLIENT_CERT_NO_PRIVATE_KEY            = (WINHTTP_ERROR_BASE + 185);
  ERROR_WINHTTP_CLIENT_CERT_NO_ACCESS_PRIVATE_KEY     = (WINHTTP_ERROR_BASE + 186);
  WINHTTP_ERROR_LAST                                  = (WINHTTP_ERROR_BASE + 186);
  
  
  // Query flags 
  WINHTTP_QUERY_MIME_VERSION                 = 0;
  WINHTTP_QUERY_CONTENT_TYPE                 = 1;
  WINHTTP_QUERY_CONTENT_TRANSFER_ENCODING    = 2;
  WINHTTP_QUERY_CONTENT_ID                   = 3;
  WINHTTP_QUERY_CONTENT_DESCRIPTION          = 4;
  WINHTTP_QUERY_CONTENT_LENGTH               = 5;
  WINHTTP_QUERY_CONTENT_LANGUAGE             = 6;
  WINHTTP_QUERY_ALLOW                        = 7;
  WINHTTP_QUERY_PUBLIC                       = 8;
  WINHTTP_QUERY_DATE                         = 9;
  WINHTTP_QUERY_EXPIRES                      = 10;
  WINHTTP_QUERY_LAST_MODIFIED                = 11;
  WINHTTP_QUERY_MESSAGE_ID                   = 12;
  WINHTTP_QUERY_URI                          = 13;
  WINHTTP_QUERY_DERIVED_FROM                 = 14;
  WINHTTP_QUERY_COST                         = 15;
  WINHTTP_QUERY_LINK                         = 16;
  WINHTTP_QUERY_PRAGMA                       = 17;
  WINHTTP_QUERY_VERSION                      = 18;
  WINHTTP_QUERY_STATUS_CODE                  = 19;
  WINHTTP_QUERY_STATUS_TEXT                  = 20;
  WINHTTP_QUERY_RAW_HEADERS                  = 21;
  WINHTTP_QUERY_RAW_HEADERS_CRLF             = 22;
  WINHTTP_QUERY_CONNECTION                   = 23;
  WINHTTP_QUERY_ACCEPT                       = 24;
  WINHTTP_QUERY_ACCEPT_CHARSET               = 25;
  WINHTTP_QUERY_ACCEPT_ENCODING              = 26;
  WINHTTP_QUERY_ACCEPT_LANGUAGE              = 27;
  WINHTTP_QUERY_AUTHORIZATION                = 28;
  WINHTTP_QUERY_CONTENT_ENCODING             = 29;
  WINHTTP_QUERY_FORWARDED                    = 30;
  WINHTTP_QUERY_FROM                         = 31;
  WINHTTP_QUERY_IF_MODIFIED_SINCE            = 32;
  WINHTTP_QUERY_LOCATION                     = 33;
  WINHTTP_QUERY_ORIG_URI                     = 34;
  WINHTTP_QUERY_REFERER                      = 35;
  WINHTTP_QUERY_RETRY_AFTER                  = 36;
  WINHTTP_QUERY_SERVER                       = 37;
  WINHTTP_QUERY_TITLE                        = 38;
  WINHTTP_QUERY_USER_AGENT                   = 39;
  WINHTTP_QUERY_WWW_AUTHENTICATE             = 40;
  WINHTTP_QUERY_PROXY_AUTHENTICATE           = 41;
  WINHTTP_QUERY_ACCEPT_RANGES                = 42;
  WINHTTP_QUERY_SET_COOKIE                   = 43;
  WINHTTP_QUERY_COOKIE                       = 44;
  WINHTTP_QUERY_REQUEST_METHOD               = 45;
  WINHTTP_QUERY_REFRESH                      = 46;
  WINHTTP_QUERY_CONTENT_DISPOSITION          = 47;
  WINHTTP_QUERY_AGE                          = 48;
  WINHTTP_QUERY_CACHE_CONTROL                = 49;
  WINHTTP_QUERY_CONTENT_BASE                 = 50;
  WINHTTP_QUERY_CONTENT_LOCATION             = 51;
  WINHTTP_QUERY_CONTENT_MD5                  = 52;
  WINHTTP_QUERY_CONTENT_RANGE                = 53;
  WINHTTP_QUERY_ETAG                         = 54;
  WINHTTP_QUERY_HOST                         = 55;
  WINHTTP_QUERY_IF_MATCH                     = 56;
  WINHTTP_QUERY_IF_NONE_MATCH                = 57;
  WINHTTP_QUERY_IF_RANGE                     = 58;
  WINHTTP_QUERY_IF_UNMODIFIED_SINCE          = 59;
  WINHTTP_QUERY_MAX_FORWARDS                 = 60;
  WINHTTP_QUERY_PROXY_AUTHORIZATION          = 61;
  WINHTTP_QUERY_RANGE                        = 62;
  WINHTTP_QUERY_TRANSFER_ENCODING            = 63;
  WINHTTP_QUERY_UPGRADE                      = 64;
  WINHTTP_QUERY_VARY                         = 65;
  WINHTTP_QUERY_VIA                          = 66;
  WINHTTP_QUERY_WARNING                      = 67;
  WINHTTP_QUERY_EXPECT                       = 68;
  WINHTTP_QUERY_PROXY_CONNECTION             = 69;
  WINHTTP_QUERY_UNLESS_MODIFIED_SINCE        = 70;
  WINHTTP_QUERY_PROXY_SUPPORT                = 75;
  WINHTTP_QUERY_AUTHENTICATION_INFO          = 76;
  WINHTTP_QUERY_PASSPORT_URLS                = 77;
  WINHTTP_QUERY_PASSPORT_CONFIG              = 78;
  WINHTTP_QUERY_MAX                          = 78;
  WINHTTP_QUERY_CUSTOM                       = 65535;
  WINHTTP_QUERY_FLAG_REQUEST_HEADERS         = $80000000;
  WINHTTP_QUERY_FLAG_SYSTEMTIME              = $40000000;
  WINHTTP_QUERY_FLAG_NUMBER                  = $20000000;
  
  // Callback options
  WINHTTP_CALLBACK_STATUS_RESOLVING_NAME          = $00000001;
  WINHTTP_CALLBACK_STATUS_NAME_RESOLVED           = $00000002;
  WINHTTP_CALLBACK_STATUS_CONNECTING_TO_SERVER    = $00000004;
  WINHTTP_CALLBACK_STATUS_CONNECTED_TO_SERVER     = $00000008;
  WINHTTP_CALLBACK_STATUS_SENDING_REQUEST         = $00000010;
  WINHTTP_CALLBACK_STATUS_REQUEST_SENT            = $00000020;
  WINHTTP_CALLBACK_STATUS_RECEIVING_RESPONSE      = $00000040;
  WINHTTP_CALLBACK_STATUS_RESPONSE_RECEIVED       = $00000080;
  WINHTTP_CALLBACK_STATUS_CLOSING_CONNECTION      = $00000100;
  WINHTTP_CALLBACK_STATUS_CONNECTION_CLOSED       = $00000200;
  WINHTTP_CALLBACK_STATUS_HANDLE_CREATED          = $00000400;
  WINHTTP_CALLBACK_STATUS_HANDLE_CLOSING          = $00000800;
  WINHTTP_CALLBACK_STATUS_DETECTING_PROXY         = $00001000;
  WINHTTP_CALLBACK_STATUS_REDIRECT                = $00004000;
  WINHTTP_CALLBACK_STATUS_INTERMEDIATE_RESPONSE   = $00008000;
  WINHTTP_CALLBACK_STATUS_SECURE_FAILURE          = $00010000;
  WINHTTP_CALLBACK_STATUS_HEADERS_AVAILABLE       = $00020000;
  WINHTTP_CALLBACK_STATUS_DATA_AVAILABLE          = $00040000;
  WINHTTP_CALLBACK_STATUS_READ_COMPLETE           = $00080000;
  WINHTTP_CALLBACK_STATUS_WRITE_COMPLETE          = $00100000;
  WINHTTP_CALLBACK_STATUS_REQUEST_ERROR           = $00200000;
  WINHTTP_CALLBACK_STATUS_SENDREQUEST_COMPLETE    = $00400000;
  WINHTTP_CALLBACK_FLAG_RESOLVE_NAME              = (WINHTTP_CALLBACK_STATUS_RESOLVING_NAME or WINHTTP_CALLBACK_STATUS_NAME_RESOLVED);
  WINHTTP_CALLBACK_FLAG_CONNECT_TO_SERVER         = (WINHTTP_CALLBACK_STATUS_CONNECTING_TO_SERVER or WINHTTP_CALLBACK_STATUS_CONNECTED_TO_SERVER);
  WINHTTP_CALLBACK_FLAG_SEND_REQUEST              = (WINHTTP_CALLBACK_STATUS_SENDING_REQUEST or WINHTTP_CALLBACK_STATUS_REQUEST_SENT);
  WINHTTP_CALLBACK_FLAG_RECEIVE_RESPONSE          = (WINHTTP_CALLBACK_STATUS_RECEIVING_RESPONSE or WINHTTP_CALLBACK_STATUS_RESPONSE_RECEIVED);
  WINHTTP_CALLBACK_FLAG_CLOSE_CONNECTION          = (WINHTTP_CALLBACK_STATUS_CLOSING_CONNECTION or WINHTTP_CALLBACK_STATUS_CONNECTION_CLOSED);
  WINHTTP_CALLBACK_FLAG_HANDLES                   = (WINHTTP_CALLBACK_STATUS_HANDLE_CREATED or WINHTTP_CALLBACK_STATUS_HANDLE_CLOSING);
  WINHTTP_CALLBACK_FLAG_DETECTING_PROXY           = WINHTTP_CALLBACK_STATUS_DETECTING_PROXY;
  WINHTTP_CALLBACK_FLAG_REDIRECT                  = WINHTTP_CALLBACK_STATUS_REDIRECT;
  WINHTTP_CALLBACK_FLAG_INTERMEDIATE_RESPONSE     = WINHTTP_CALLBACK_STATUS_INTERMEDIATE_RESPONSE;
  WINHTTP_CALLBACK_FLAG_SECURE_FAILURE            = WINHTTP_CALLBACK_STATUS_SECURE_FAILURE;
  WINHTTP_CALLBACK_FLAG_SENDREQUEST_COMPLETE      = WINHTTP_CALLBACK_STATUS_SENDREQUEST_COMPLETE;
  WINHTTP_CALLBACK_FLAG_HEADERS_AVAILABLE         = WINHTTP_CALLBACK_STATUS_HEADERS_AVAILABLE;
  WINHTTP_CALLBACK_FLAG_DATA_AVAILABLE            = WINHTTP_CALLBACK_STATUS_DATA_AVAILABLE;
  WINHTTP_CALLBACK_FLAG_READ_COMPLETE             = WINHTTP_CALLBACK_STATUS_READ_COMPLETE;
  WINHTTP_CALLBACK_FLAG_WRITE_COMPLETE            = WINHTTP_CALLBACK_STATUS_WRITE_COMPLETE;
  WINHTTP_CALLBACK_FLAG_REQUEST_ERROR             = WINHTTP_CALLBACK_STATUS_REQUEST_ERROR;
  WINHTTP_CALLBACK_FLAG_ALL_COMPLETIONS           = (WINHTTP_CALLBACK_STATUS_SENDREQUEST_COMPLETE or WINHTTP_CALLBACK_STATUS_HEADERS_AVAILABLE
                                                          or WINHTTP_CALLBACK_STATUS_DATA_AVAILABLE or WINHTTP_CALLBACK_STATUS_READ_COMPLETE 
                                                          or WINHTTP_CALLBACK_STATUS_WRITE_COMPLETE or WINHTTP_CALLBACK_STATUS_REQUEST_ERROR);
  WINHTTP_CALLBACK_FLAG_ALL_NOTIFICATIONS         = $FFFFFFFF;
  WINHTTP_INVALID_STATUS_CALLBACK: Pointer  = Pointer(-1);


  // flags for WinHttp{Set/Query}Options 
  WINHTTP_OPTION_CALLBACK                       = 1;
  WINHTTP_FIRST_OPTION                          = WINHTTP_OPTION_CALLBACK;
  WINHTTP_OPTION_RESOLVE_TIMEOUT                = 2;
  WINHTTP_OPTION_CONNECT_TIMEOUT                = 3;
  WINHTTP_OPTION_CONNECT_RETRIES                = 4;
  WINHTTP_OPTION_SEND_TIMEOUT                   = 5;
  WINHTTP_OPTION_RECEIVE_TIMEOUT                = 6;
  WINHTTP_OPTION_RECEIVE_RESPONSE_TIMEOUT       = 7;
  WINHTTP_OPTION_HANDLE_TYPE                    = 9;
  WINHTTP_OPTION_READ_BUFFER_SIZE              = 12;
  WINHTTP_OPTION_WRITE_BUFFER_SIZE             = 13;
  WINHTTP_OPTION_PARENT_HANDLE                 = 21;
  WINHTTP_OPTION_EXTENDED_ERROR                = 24;
  WINHTTP_OPTION_SECURITY_FLAGS                = 31;
  WINHTTP_OPTION_SECURITY_CERTIFICATE_STRUCT   = 32;
  WINHTTP_OPTION_URL                           = 34;
  WINHTTP_OPTION_SECURITY_KEY_BITNESS          = 36;
  WINHTTP_OPTION_PROXY                         = 38;
  WINHTTP_OPTION_USER_AGENT                    = 41;
  WINHTTP_OPTION_CONTEXT_VALUE                 = 45;
  WINHTTP_OPTION_CLIENT_CERT_CONTEXT           = 47;
  WINHTTP_OPTION_REQUEST_PRIORITY              = 58;
  WINHTTP_OPTION_HTTP_VERSION                  = 59;
  WINHTTP_OPTION_DISABLE_FEATURE               = 63;
  WINHTTP_OPTION_CODEPAGE                      = 68;
  WINHTTP_OPTION_MAX_CONNS_PER_SERVER          = 73;
  WINHTTP_OPTION_MAX_CONNS_PER_1_0_SERVER      = 74;
  WINHTTP_OPTION_AUTOLOGON_POLICY              = 77;
  WINHTTP_OPTION_SERVER_CERT_CONTEXT           = 78;
  WINHTTP_OPTION_ENABLE_FEATURE                = 79;
  WINHTTP_OPTION_WORKER_THREAD_COUNT           = 80;
  WINHTTP_OPTION_PASSPORT_COBRANDING_TEXT      = 81;
  WINHTTP_OPTION_PASSPORT_COBRANDING_URL       = 82;
  WINHTTP_OPTION_CONFIGURE_PASSPORT_AUTH       = 83;
  WINHTTP_OPTION_SECURE_PROTOCOLS              = 84;
  WINHTTP_OPTION_ENABLETRACING                 = 85;
  WINHTTP_OPTION_PASSPORT_SIGN_OUT             = 86;
  WINHTTP_OPTION_PASSPORT_RETURN_URL           = 87;
  WINHTTP_OPTION_REDIRECT_POLICY               = 88;
  WINHTTP_OPTION_MAX_HTTP_AUTOMATIC_REDIRECTS  = 89;
  WINHTTP_OPTION_MAX_HTTP_STATUS_CONTINUE      = 90;
  WINHTTP_OPTION_MAX_RESPONSE_HEADER_SIZE      = 91;
  WINHTTP_OPTION_MAX_RESPONSE_DRAIN_SIZE       = 92;
  WINHTTP_OPTION_CONNECTION_INFO               = 93;
  WINHTTP_OPTION_CLIENT_CERT_ISSUER_LIST       = 94;
  WINHTTP_OPTION_SPN                           = 96;
  WINHTTP_OPTION_GLOBAL_PROXY_CREDS            = 97;
  WINHTTP_OPTION_GLOBAL_SERVER_CREDS           = 98;
  WINHTTP_OPTION_UNLOAD_NOTIFY_EVENT           = 99;
  WINHTTP_OPTION_REJECT_USERPWD_IN_URL         = 100;
  WINHTTP_OPTION_USE_GLOBAL_SERVER_CREDENTIALS = 101;
  WINHTTP_LAST_OPTION                          = WINHTTP_OPTION_USE_GLOBAL_SERVER_CREDENTIALS;
  WINHTTP_OPTION_USERNAME                      = $1000;
  WINHTTP_OPTION_PASSWORD                      = $1001;
  WINHTTP_OPTION_PROXY_USERNAME                = $1002;
  WINHTTP_OPTION_PROXY_PASSWORD                = $1003;

  WINHTTP_CONNS_PER_SERVER_UNLIMITED = $FFFFFFFF;

  WINHTTP_AUTOLOGON_SECURITY_LEVEL_MEDIUM   = 0;
  WINHTTP_AUTOLOGON_SECURITY_LEVEL_LOW      = 1;
  WINHTTP_AUTOLOGON_SECURITY_LEVEL_HIGH     = 2;
  WINHTTP_AUTOLOGON_SECURITY_LEVEL_DEFAULT  = WINHTTP_AUTOLOGON_SECURITY_LEVEL_MEDIUM;

  WINHTTP_OPTION_REDIRECT_POLICY_NEVER                        = 0;
  WINHTTP_OPTION_REDIRECT_POLICY_DISALLOW_HTTPS_TO_HTTP       = 1;
  WINHTTP_OPTION_REDIRECT_POLICY_ALWAYS                       = 2;
  WINHTTP_OPTION_REDIRECT_POLICY_LAST            = WINHTTP_OPTION_REDIRECT_POLICY_ALWAYS;
  WINHTTP_OPTION_REDIRECT_POLICY_DEFAULT         = WINHTTP_OPTION_REDIRECT_POLICY_DISALLOW_HTTPS_TO_HTTP;
  WINHTTP_DISABLE_PASSPORT_AUTH    = $00000000;
  WINHTTP_ENABLE_PASSPORT_AUTH     = $10000000;
  WINHTTP_DISABLE_PASSPORT_KEYRING = $20000000;
  WINHTTP_ENABLE_PASSPORT_KEYRING  = $40000000;

  WINHTTP_DISABLE_COOKIES                   = $00000001;
  WINHTTP_DISABLE_REDIRECTS                 = $00000002;
  WINHTTP_DISABLE_AUTHENTICATION            = $00000004;
  WINHTTP_DISABLE_KEEP_ALIVE                = $00000008;
  WINHTTP_ENABLE_SSL_REVOCATION             = $00000001;
  WINHTTP_ENABLE_SSL_REVERT_IMPERSONATION   = $00000002;
  WINHTTP_DISABLE_SPN_SERVER_PORT           = $00000000;
  WINHTTP_ENABLE_SPN_SERVER_PORT            = $00000001;
  WINHTTP_OPTION_SPN_MASK                   = WINHTTP_ENABLE_SPN_SERVER_PORT;





function WinHttpAddRequestHeaders(hRequest: HINTERNET; pwszHeaders: PWideChar; dwHeadersLength: DWORD;
           dwModifiers: DWORD): BOOL; stdcall; external winhttpdll;

function WinHttpCheckPlatform(): BOOL; stdcall; external winhttpdll;

function WinHttpCloseHandle(hInternet: HINTERNET): BOOL; stdcall; external winhttpdll;

function WinHttpConnect(hSession: HINTERNET; pswzServerName: PWideChar;
           nServerPort: INTERNET_PORT; dwReserved: DWORD): HINTERNET; stdcall; external winhttpdll;

function WinHttpOpen(pwszUserAgent: PWideChar; dwAccessType: DWORD;
  pwszProxyName, pwszProxyBypass: PWideChar; dwFlags: DWORD): HINTERNET; stdcall; external winhttpdll;

function WinHttpOpenRequest(hConnect: HINTERNET; pwszVerb: PWideChar;
           pwszObjectName: PWideChar; pwszVersion: PWideChar; pwszReferer: PWideChar;
           ppwszAcceptTypes: Pointer; dwFlags: DWORD): HINTERNET; stdcall; external winhttpdll;

function WinHttpQueryAuthSchemes(hRequest: HINTERNET; var dwSupportedSchemes, dwFirstScheme, dwAuthTarget: DWORD): BOOL; stdcall; external winhttpdll;

function WinHttpQueryDataAvailable(hRequest: HINTERNET; var lpdwNumberOfBytesAvailable: DWORD): BOOL; stdcall; external winhttpdll;

function WinHttpQueryHeaders(hRequest: HINTERNET; dwInfoLevel: DWORD; pwszName: PWideChar;
           lpBuffer: Pointer; var lpdwBufferLength: DWORD; lpdwIndex: PDWORD): BOOL; stdcall; external winhttpdll;

function WinHttpQueryOption(hInternet: HINTERNET; dwOption: DWORD; lpBuffer: Pointer; var lpdwBufferLength: DWORD): BOOL; stdcall; external winhttpdll;

function WinHttpReadData(hRequest: HINTERNET; lpBuffer: Pointer;
           dwNumberOfBytesToRead: DWORD; var lpdwNumberOfBytesRead: DWORD): BOOL; stdcall; external winhttpdll;

function WinHttpReceiveResponse(hRequest: HINTERNET; lpReserved: Pointer): BOOL; stdcall; external winhttpdll;

function WinHttpSendRequest(hRequest: HINTERNET; pwszHeaders: PWideChar; dwHeadersLength: DWORD; 
           lpOptional: Pointer; dwOptionalLength: DWORD; dwTotalLength: DWORD; dwContext: Pointer): BOOL; stdcall; external winhttpdll;

function WinHttpSetCredentials(hRequest: HINTERNET; AuthTarget, AuthScheme: DWORD; pwszUserName, pwszPassword: PWideChar;
           pAuthParams: Pointer): BOOL; stdcall; external winhttpdll;

function WinHttpSetOption(hInternet: HINTERNET; dwOption: DWORD; lpBuffer: Pointer; dwBufferLength: DWORD): BOOL; stdcall; external winhttpdll;

function WinHttpSetStatusCallback(hInternet: HINTERNET; lpfnInternetCallback: WINHTTP_STATUS_CALLBACK; 
           dwNotificationFlags: DWORD; dwReserved: DWORD): Pointer; stdcall; external winhttpdll;

function WinHttpSetTimeouts(hInternet: HINTERNET; dwResolveTimeout, dwConnectTimeout, 
           dwSendTimeout, dwReceiveTimeout: DWORD): BOOL; stdcall; external winhttpdll;

function WinHttpWriteData(hRequest: HINTERNET; lpBuffer: Pointer; dwNumberOfBytesToWrite: DWORD; 
           var lpdwNumberOfBytesWritten: DWORD): BOOL; stdcall; external winhttpdll;

implementation

end.
