unit hiURLParser;

interface

uses Windows, Share, Kol, uri;

type
  
  ThiURLParser = class
    private
      FURI: TURI;
      
    public
      _prop_DefaultProtocol: string;
      _prop_DefaultPort: string;
      _data_URL:THI_Event;

      procedure _work_doParse(var _Data:TData; Index:word);
      
      procedure _var_Host(var _Data:TData; Index:word);
      procedure _var_FullPath(var _Data:TData; Index:word);
      procedure _var_Path(var _Data:TData; Index:word);
      procedure _var_Document(var _Data:TData; Index:word);
      procedure _var_Params(var _Data:TData; Index:word);
      procedure _var_Bookmark(var _Data:TData; Index:word);
      procedure _var_Protocol(var _Data:TData; Index:word);
      procedure _var_Port(var _Data:TData; Index:word);
      procedure _var_Username(var _Data:TData; Index:word);
      procedure _var_Password(var _Data:TData; Index:word);
      
      constructor Create;
      destructor Destroy; override;
  end;

implementation


constructor ThiURLParser.Create;
begin
  FURI := TURI.Create;
end;


destructor ThiURLParser.Destroy;
begin
  FURI.Free;
end;


procedure ThiURLParser._work_doParse;
begin
  FURI.URI := ReadString(_Data, _data_URL, '');
end;


procedure ThiURLParser._var_Host;
begin
  dtString(_Data, FURI.Host);
end;

procedure ThiURLParser._var_FullPath;
begin
  dtString(_Data, FURI.GetFullURI([ofParams, ofBookmark]));
end;

procedure ThiURLParser._var_Path;
begin
  dtString(_Data, FURI.Path);
end;

procedure ThiURLParser._var_Document;
begin
  dtString(_Data, FURI.Document);
end;

procedure ThiURLParser._var_Params;
begin
  dtString(_Data, FURI.Params);
end;

procedure ThiURLParser._var_Bookmark;
begin
  dtString(_Data, FURI.Bookmark);
end;

procedure ThiURLParser._var_Protocol;
begin
  dtString(_Data, FURI.Protocol);
end;

procedure ThiURLParser._var_Port;
var s: string;
begin
  s := FURI.Port;
  if Length(s) = 0 then s := _prop_DefaultPort;
  dtString(_Data, s);
end;

procedure ThiURLParser._var_Username;
begin
  dtString(_Data, FURI.Username);
end;

procedure ThiURLParser._var_Password;
begin
  dtString(_Data, FURI.Password);
end;


end.